clang 10.0.0git

Public Member Functions | Friends | List of all members
clang::CFGTemporaryDtor Class Reference

Represents C++ object destructor implicitly generated at the end of full expression for temporary object. More...

`#include "clang/Analysis/CFG.h"`

Inheritance diagram for clang::CFGTemporaryDtor:
[legend]
Collaboration diagram for clang::CFGTemporaryDtor:
[legend]

## Public Member Functions
| CFGTemporaryDtor (CXXBindTemporaryExpr *expr)
const CXXBindTemporaryExpr * | getBindTemporaryExpr () const
Public Member Functions inherited from clang::CFGImplicitDtor
const CXXDestructorDecl * | getDestructorDecl (ASTContext &astContext) const
bool | isNoReturn (ASTContext &astContext) const
Public Member Functions inherited from clang::CFGElement
template<typename T >
T | castAs () const
| Convert to the specified CFGElement type, asserting that this CFGElement is of the desired type. More...
template<typename T >
Optional< T > | getAs () const
| Convert to the specified CFGElement type, returning None if this CFGElement is not of the desired type. More...
Kind | getKind () const
void | dumpToStream (llvm::raw_ostream &OS) const
void | dump () const

## Friends
class | CFGElement

## Additional Inherited Members
Public Types inherited from clang::CFGElement
enum | Kind { Initializer, ScopeBegin, ScopeEnd, NewAllocator, LifetimeEnds, LoopExit, Statement, Constructor, CXXRecordTypedCall, STMT_BEGIN = Statement, STMT_END = CXXRecordTypedCall, AutomaticObjectDtor, DeleteDtor, BaseDtor, MemberDtor, TemporaryDtor, DTOR_BEGIN = AutomaticObjectDtor, DTOR_END = TemporaryDtor }
Protected Member Functions inherited from clang::CFGImplicitDtor
| CFGImplicitDtor ()=default
| CFGImplicitDtor (Kind kind, const void *data1, const void *data2=nullptr)
Protected Member Functions inherited from clang::CFGElement
| CFGElement (Kind kind, const void *Ptr1, const void *Ptr2=nullptr)
| CFGElement ()=default
Protected Attributes inherited from clang::CFGElement
llvm::PointerIntPair< void *, 2 > | Data1
llvm::PointerIntPair< void *, 2 > | Data2

## Detailed Description

Represents C++ object destructor implicitly generated at the end of full expression for temporary object.

Definition at line 482 of file CFG.h.

## Constructor & Destructor Documentation

## ◆ CFGTemporaryDtor()

clang::CFGTemporaryDtor::CFGTemporaryDtor | ( | CXXBindTemporaryExpr * | expr | ) |
| inline

Definition at line 484 of file CFG.h.

## Member Function Documentation

## ◆ getBindTemporaryExpr()

const CXXBindTemporaryExpr* clang::CFGTemporaryDtor::getBindTemporaryExpr | ( |  | ) | const
| inline

Definition at line 487 of file CFG.h.

References clang::CFGElement::Data1.

Referenced by clang::ento::ExprEngine::ProcessTemporaryDtor(), and clang::consumed::ConsumedAnalyzer::run().

## Friends And Related Function Documentation

## ◆ CFGElement

friend class CFGElement
| friend

Definition at line 492 of file CFG.h.

The documentation for this class was generated from the following file:

- include/clang/Analysis/CFG.h